#!/usr/bin/perl
##############################################################################
# Contact Form script               Version 1.0                              #
# Copyright 1998 UtilMind Solutions info@utilmind.com                        #
#                                   http://www.utilmind.com                  #
# Created Sep 11, 1998              Last Modified Sep 11, 1998               #
##############################################################################
# COPYRIGHT NOTICE                                                           #
# Copyright 1998 by UtilMind Solutions. All Rights Reserved.                 #
#                                                                            #
# This software redistributed as FREEWARE. It means that this script may be  #
# used and modified free of charge by anyone so long as this copyright       #
# notice and the comments above remain intact.  By using this code you agree #
# indemnify UtilMind Solutions from any liability that might arise from it's #
# use.                                                                       #
#                                                                            #
# Selling the code for this program without prior written consent is         #
# expressly forbidden. In other words, please ask first before you try and   #
# make money off of my program.                                              #
#                                                                            #
# Obtain permission before redistributing this software over the Internet or #
# in any other medium. In all cases copyright and header must remain intact. #
##############################################################################

# Set Variables

$mailprog	= '/usr/sbin/sendmail';
$thank_url      = 'http://www.your-url.com/thankyou.htm';
$archivefile	= 'contact.txt';
$toname		= 'UtilMind Solutions';
$tomail		= 'info@utilmind.com';

@months = ("January","February","March","April","May","June",
           "July","August","September","October","November","December");
$at = "at"; # ..at time... For example, in Russian this value must be "";

$timeoffset = 0;
$timezone   = '(GMT)';


#######################
# Begining of code

# Get the input
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});

# Split the name-value pairs
@pairs = split(/&/, $buffer);

foreach $pair (@pairs) {
   ($name, $value) = split(/=/, $pair);

   # Un-Webify plus signs and %-encoding
   $value =~ tr/+/ /;
   $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
   $value =~ s/<!--(.|\n)*-->//g;

   $FORM{$name} = $value;
}

($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = gmtime(time+$timeoffset*3600);
$time = sprintf("%02d:%02d",$hour,$min);
$year += 1900;
$date = "$mday $months[$mon] $year $at $time $timezone";


open(HANDLE,"|$mailprog -t") || die "Can't open $mailprog!\n";
&send_message;
close(HANDLE);

open(HANDLE, ">>$archivefile") || die "Can't open archive file for writing: $!";
&send_message;
print HANDLE "\n=======================================\n\n";
close(HANDLE);

print "Location: $thank_url\n\n";;

sub send_message {
  print HANDLE "To: $toname <$tomail>\n";
  print HANDLE "From: $FORM{'name'} <$FORM{'email'}>\n";
  print HANDLE "Subject: $FORM{'subject'}\n\n";
  print HANDLE "$date\n";
  print HANDLE "  This message has sent from $ENV{'HTTP_REFERER'}.\n";
  print HANDLE "  IP address: $ENV{'REMOTE_ADDR'}, Remote host: $ENV{'REMOTE_HOST'}.\n";
  print HANDLE "  User's WebSite is: $FORM{'url'}\n";
  print HANDLE "------------------------------\n\n";
  print HANDLE "$FORM{'message'}";
}
